#!/usr/bin/python
# -*- coding: utf-8 -*-

from PyQt4 import QtGui,QtCore
from qt4main import *
from config import *
from about import *
import sys
import os
from ConfigParser import RawConfigParser
import get_config
from datetime import datetime, timedelta
import dateutil
from dateutil.rrule import *
import glob
currentVersion = 1.0

class mainwindow(QtGui.QDialog):
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)
        self.f = Ui_Dialog()
        self.f.setupUi(self)
        self.f.tabWidget.setCurrentIndex(0)
        self.checkVersion()
        self.f.spinBox.setValue(int(str(datetime.now()).split('-')[0]))
        self.getTemplates()
        QtCore.QObject.connect(self.f.getInterval,QtCore.SIGNAL("clicked()"),self.deltaDates)
        QtCore.QObject.connect(self.f.addButton,QtCore.SIGNAL("clicked()"),self.addNumber)
        QtCore.QObject.connect(self.f.subtractButton,QtCore.SIGNAL("clicked()"),self.subtractNumber)
        QtCore.QObject.connect(self.f.setHolidays,QtCore.SIGNAL("clicked()"),self.startConfig)
        QtCore.QObject.connect(self.f.aboutButton,QtCore.SIGNAL("clicked()"),self.aboutDialog)
        QtCore.QObject.connect(self.f.tabWidget,QtCore.SIGNAL("currentChanged(int)"),self.changeIncl)
        QtCore.QObject.connect(self.f.workingDays,QtCore.SIGNAL("stateChanged(int)"),self.workCheck)
        QtCore.QObject.connect(self.f.spinBox,QtCore.SIGNAL("valueChanged(int)"),self.showHolidays)
        QtCore.QObject.connect(self.f.comboBox,QtCore.SIGNAL("currentIndexChanged(QString)"),self.templateChanged)
        QtCore.QObject.connect(self.f.pushButton,QtCore.SIGNAL("clicked()"),self.printReport)
        config = get_config.getConfig()
        self.f.comboBox.setCurrentIndex(self.f.comboBox.findText(config.tmplt))

    def printReport(self):
        import report
        reportfile = QtGui.QFileDialog.getSaveFileName(self.f.pushButton,"Save Report",os.path.expanduser('~'),"PDF File (*.pdf)")
        if len(reportfile) > 0:
            report.go(reportfile,self.f)

    def templateChanged(self):
        if os.name == "nt":
            config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\date_config'
        else:
            home_directory = os.popen("echo $HOME").readline()[0:-1]
            config_file = home_directory + '/.date_config/date_config'
        config_object = RawConfigParser()
        config_object.read(config_file)
        try:
            holoptions = config_object.options('Holidays')
            print holoptions
            options = []
            for i in holoptions:
                option = config_object.get('Holidays',i)
                options.append(option)
            try:
                config_object.add_section('Holidays')
            except:
                pass
            for i in range(len(holoptions)):
                config_object.set('Holidays',holoptions[i],options[i])
        except:
            pass
        try:
            config_object.add_section('Template')
        except:
            pass
        config_object.set('Template','current',self.f.comboBox.currentText())
        confile = open(config_file,'w')
        config_object.write(confile)
        confile.close()
        self.showHolidays()

    def getConfig(self):
        print "Getting Configuration ..."
        gf = 0
        es = 0
        em = 0
        fixed_raw = []
        variable_raw = []
        variable_ext_raw = []
        grang_raw = []
        fixed_dict = {}
        variable_dict = {}
        variable_ext_dict = {}
        grange_dict = {}
        if self.f.comboBox.currentText() == 'Default':
            filename = 'date_config'
        else:
            filename = str(self.f.comboBox.currentText()) + '.dctmplt'
        if os.name == "nt":
            config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\' + filename
        else:
            home_directory = os.popen("echo $HOME").readline()[0:-1]
            config_file = home_directory + '/.date_config/' + filename
        config = RawConfigParser()
        try:
            config.read(config_file)
            fixed_dict = eval(config.get('Holidays','fixed'))
            variable_dict = eval(config.get('Holidays','variable'))
            variable_ext_dict = eval(config.get('Holidays','variable_ext'))
            grange_dict = eval(config.get('Holidays','grange'))
            gf = config.getint('Holidays','gf')
            es = config.getint('Holidays','es')
            em = config.getint('Holidays','em')
            fixed_raw = []
            for i in fixed_dict.keys():
                fixed_raw.append([fixed_dict[i][0],fixed_dict[i][1] + 1])
            print "fixed_raw:"
            print fixed_raw
            variable_raw = []
            for i in variable_dict.keys():
                variable_raw.append([rel_matrix[variable_dict[i][0]],wkday_matrix[variable_dict[i][1]],variable_dict[i][2] + 1])
            print "variable_raw:"
            print variable_raw
            variable_ext_raw = []
            for i in variable_ext_dict.keys():
                variable_ext_raw.append([wkday_matrix[variable_ext_dict[i][0]],variable_ext_dict[i][1],variable_ext_dict[i][2] + 1])
            print "variable_ext_raw:"
            print variable_ext_raw
            grange_raw = []
            for i in grange_dict.keys():
                start = datetime(2006,grange_dict[i][1] + 1,grange_dict[i][0])
                end = datetime(2006,grange_dict[i][3] + 1,grange_dict[i][2])
                r = (end+timedelta(days=1)-start).days
                dateList = [start+timedelta(days=j) for j in range(r)]
                print start
                print end
                print dateList
                for p in dateList:
                    raw = str(p)
                    thisdate = raw.split()[0].split('-')
                    thismonth = int(thisdate[1])
                    thisday = int(thisdate[2])
                    grange_raw.append([thisday,thismonth])
            print "grange_raw:"
            print grange_raw
            
        except:
            print "Couldn't get data from file.  Using defaults ..."
        return (gf,es,em,fixed_raw,variable_raw,variable_ext_raw,grange_raw)


    def getTemplates(self):
        self.f.comboBox.clear()
        self.f.comboBox.addItem("Default")
        if os.name == 'nt':
            anytmplts = glob.glob(os.path.expandvars("%appdata%") + '\\date_calculator\\*.dctmplt')
            for i in anytmplts:
                tmpltname = i.split('\\')[-1].split('.')[0]
                self.f.comboBox.addItem(tmpltname)
        else:
            home_directory = os.popen("echo $HOME").readline()[0:-1]
            anytmplts = glob.glob(home_directory + '/.date_config/*.dctmplt')
            for i in anytmplts:
                tmpltname = i.split('/')[-1].split('.')[0]
                self.f.comboBox.addItem(tmpltname)


    def workCheck(self,check):
        if check == 0:
            self.f.textEdit.setEnabled(False)
        if check == 2:
            self.f.textEdit.setEnabled(True)

    def changeIncl(self,page):
        if page == 0:
            self.f.checkBox.setEnabled(True)
        if page == 1:
            self.f.checkBox.setEnabled(False)

    def aboutDialog(self):
        d = about()
        d.exec_()

    def showHolidays(self):
        self.f.treeWidget.clear()
        year = self.f.spinBox.value()
        print "Getting Configuration ..."
        gf = 0
        es = 0
        em = 0
        fixed_raw = []
        variable_raw = []
        variable_ext_raw = []
        grang_raw = []
        fixed_dict = {}
        variable_dict = {}
        variable_ext_dict = {}
        grange_dict = {}
        if self.f.comboBox.currentText() == 'Default':
            filename = 'date_config'
        else:
            filename = str(self.f.comboBox.currentText()) + '.dctmplt'
        if os.name == "nt":
            config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\' + filename
        else:
            home_directory = os.popen("echo $HOME").readline()[0:-1]
            config_file = home_directory + '/.date_config/' + filename
        config = RawConfigParser()
        print config_file
        #try:
        config.read(config_file)
        fixed_dict = eval(config.get('Holidays','fixed'))
        variable_dict = eval(config.get('Holidays','variable'))
        variable_ext_dict = eval(config.get('Holidays','variable_ext'))
        grange_dict = eval(config.get('Holidays','grange'))
        gf = config.getint('Holidays','gf')
        es = config.getint('Holidays','es')
        em = config.getint('Holidays','em')
        print grange_dict
        #except:
            #pass
        holidayList = []
        print fixed_dict
        for key in fixed_dict:
            thisHoliday = []
            thisHoliday.append(key)
            date = QtCore.QDate(int(year),fixed_dict[key][1]+1,fixed_dict[key][0])
            thisHoliday.append(date)
            wkday = date.dayOfWeek()
            thisHoliday.append(wkday)
            holidayList.append(thisHoliday)
        if gf == 1:
            thisHoliday = []
            thisHoliday.append('Good Friday')
            goodf = dateutil.easter.easter(int(year)) - timedelta(days=2)
            date = QtCore.QDate(goodf)
            thisHoliday.append(date)
            wkday = date.dayOfWeek()
            thisHoliday.append(wkday)
            holidayList.append(thisHoliday)
        if es == 1:
            thisHoliday = []
            thisHoliday.append('Easter Sunday')
            goodf = dateutil.easter.easter(int(year))
            date = QtCore.QDate(goodf)
            thisHoliday.append(date)
            wkday = date.dayOfWeek()
            thisHoliday.append(wkday)
            holidayList.append(thisHoliday)
        if em == 1:
            thisHoliday = []
            thisHoliday.append('Easter Monday')
            goodf = dateutil.easter.easter(int(year)) + timedelta(days=1)
            date = QtCore.QDate(goodf)
            thisHoliday.append(date)
            wkday = date.dayOfWeek()
            thisHoliday.append(wkday)
            holidayList.append(thisHoliday)
        for key in variable_ext_dict:
            thisHoliday = []
            thisHoliday.append(key)
            reldate = QtCore.QDate(int(year),variable_ext_dict[key][2]+1,variable_ext_dict[key][3])
            wkday = reldate.dayOfWeek()
            for i in range(-3,4):
                print i
                if reldate.addDays(i).dayOfWeek() == variable_ext_dict[key][0]+1:
                    date = reldate.addDays(i)
                    break
            thisHoliday.append(date)
            wkday = date.dayOfWeek()
            thisHoliday.append(wkday)
            holidayList.append(thisHoliday)
        for key in variable_dict:
            week_matrix = [MO,TU,WE,TH,FR]
            thisHoliday = []
            thisHoliday.append(key)
            datelist = list(rrule(YEARLY,count=1,bymonth=variable_dict[key][2]+1,byweekday=week_matrix[variable_dict[key][1]](variable_dict[key][0]+1),dtstart=datetime(int(year),1,1)))
            tmpdate = str(datelist[0]).split()[0].split('-')
            date = QtCore.QDate(int(tmpdate[0]),int(tmpdate[1]),int(tmpdate[2]))
            thisHoliday.append(date)
            wkday = variable_dict[key][1]
            thisHoliday.append(wkday)
            holidayList.append(thisHoliday)
        for i in grange_dict.keys():
            start = datetime(int(year),grange_dict[i][1] + 1,grange_dict[i][0])
            end = datetime(int(year),grange_dict[i][3] + 1,grange_dict[i][2])
            r = (end+timedelta(days=1)-start).days
            dateList = [start+timedelta(days=j) for j in range(r)]
            print start
            print end
            print dateList
            for p in dateList:
                thisHoliday = []
                thisHoliday.append(i)
                raw = str(p).split()[0].split('-')
                date = QtCore.QDate(int(raw[0]),int(raw[1]),int(raw[2]))
                thisHoliday.append(date)
                wkday = date.dayOfWeek()
                thisHoliday.append(wkday)
                holidayList.append(thisHoliday)
        print holidayList
        for passesLeft in range(len(holidayList)-1, 0, -1):
            for index in range(passesLeft):
                if holidayList[index][1] > (holidayList[index + 1][1]):
                    holidayList[index], holidayList[index + 1] = holidayList[index + 1], holidayList[index]
        for i in holidayList:
            items = [i[0],i[1].toString("d MMM"),i[1].longDayName(i[2])]
            item = QtGui.QTreeWidgetItem(items)
            self.f.treeWidget.addTopLevelItem(item)
        
        print holidayList
            
            


    def checkVersion(self):
        import socket
        import urllib2
        messageflag = 0
        if os.name == "nt":
            try:
                os.mkdir(os.path.expandvars("%appdata%") + '\\date_calculator')
            except:
                pass
            config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\latest'
        else:
            home_directory = os.popen("echo $HOME").readline()[0:-1]
            config_file = home_directory + '/.date_config/latest'
            try:
                os.mkdir(home_directory + '/.date_config')
            except:
                pass
        try:
            os.mknod(config_file)
        except:
            pass
        #config_file = open(conf_file,'w')
        config = RawConfigParser()
        config.read(config_file)
        print config
        try:
            req = urllib2.Request('http://everydaylht.com/applications/date_calculator/version.txt')
            response = urllib2.urlopen(req)
            versionlatest = float(response.read())
            versioncacheold = 0
            try:
                latest = config.getfloat("Version","latest")
                print latest
                if versionlatest > latest:
                    versioncacheold = 1
                else:
                    print "Version Check:  Update message already shown"
            except:
                print "No cached version"
                versioncacheold = 1
            if (versionlatest > float(currentVersion)) and (versioncacheold == 1):
                messageflag = 1
            if (versionlatest == float(currentVersion)):
                print "Version Check:  This is the latest version"
            if messageflag == 1:
                QtGui.QMessageBox.information(self.f.spinBox, "New Version Available", "There is a new version of Date Calculator available.\nDownload it from http://everydaylht.com/my-apps/date-calculator")
            if versioncacheold == 1:
                config_object = open(config_file,'w')
                try:
                    config.add_section('Version')
                except:
                    pass
                config.set('Version','latest', str(versionlatest))
                config.write(config_object)
                config_object.close()
        except:
            print "Unable to download latest version information"



    def addNumber(self):
        working = ' '
        if self.f.workingDays.isChecked() == 1:
            working = ' working '
        inclusive = ' '
        if self.f.includeDays.isChecked() == 1:
            inclusive = ' (incl. start date) '
        startdate = self.f.calendarWidget.selectedDate()
        self.f.questionLabel.setText(str(startdate.day()) + ' ' + str(startdate.toString("MMMM")) + ' ' + str(startdate.year()) + ' plus ' + str(self.f.dayNumber.value()) + working + 'day(s)' + inclusive + 'is:')
        if int(self.f.workingDays.isChecked()) == 1:
            self.f.answerLabel.setText("Calculating Answer ...")
        import get_config
        reload(get_config)
        getConfig = get_config.getConfig()
        from datetime import datetime
        from calculator import *
        month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
        answer = addDays(datetime(int(startdate.year()),int(startdate.month()),int(startdate.day())),int(self.f.dayNumber.value()),getConfig.fixed_raw,getConfig.variable_raw,getConfig.variable_ext_raw,getConfig.gf,getConfig.em,getConfig.grange_raw,self.f,int(self.f.workingDays.isChecked()),int(self.f.includeDays.isChecked()))
        print answer
        interim_date = str(answer).split('-')
        print interim_date
        text = interim_date[2] + ' ' + month_matrix[int(interim_date[1])-1] + ' ' + interim_date[0]
        self.f.answerLabel.setText(text)
        

    def subtractNumber(self):
        working = ' '
        if self.f.workingDays.isChecked() == 1:
            working = ' working '
        inclusive = ' '
        if self.f.includeDays.isChecked() == 1:
            inclusive = ' (incl. start date) '
        startdate = self.f.calendarWidget.selectedDate()
        self.f.questionLabel.setText(str(startdate.day()) + ' ' + str(startdate.toString("MMMM")) + ' ' + str(startdate.year()) + ' minus ' + str(self.f.dayNumber.value()) + working + 'day(s)' + inclusive + 'is:')
        if int(self.f.workingDays.isChecked()) == 1:
            self.f.answerLabel.setText("Calculating Answer ...")
        import get_config
        reload(get_config)
        getConfig = get_config.getConfig()
        from datetime import datetime
        from calculator import *
        month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
        answer = subDays(datetime(int(startdate.year()),int(startdate.month()),int(startdate.day())),int(self.f.dayNumber.value()),getConfig.fixed_raw,getConfig.variable_raw,getConfig.variable_ext_raw,getConfig.gf,getConfig.em,getConfig.grange_raw,self.f,int(self.f.workingDays.isChecked()),int(self.f.includeDays.isChecked()))
        interim_date = str(answer).split('-')
        text = interim_date[2] + ' ' + month_matrix[int(interim_date[1])-1] + ' ' + interim_date[0]
        self.f.answerLabel.setText(text)
        

    def deltaDates(self):
        from datetime import datetime
        from dateutil.relativedelta import *
        errorflag = 0
        startdate = self.f.calendarWidget.selectedDate()
        enddate = self.f.calendarWidget_2.selectedDate()
        if startdate == enddate:
            QtGui.QMessageBox.critical(self.f.calendarWidget, "Invalid Dates", "The start date cannot be the same as the end date.")
            errorflag = 1
        test = relativedelta(datetime(int(startdate.year()),int(startdate.month()),int(startdate.day())),datetime(int(enddate.year()),int(enddate.month()),int(enddate.day())))
        for i in (test.days, test.months, test.years):
            if i > 0:
                errorflag = 1
                QtGui.QMessageBox.critical(self.f.calendarWidget, "Invalid Date", "The start date must be earlier than the end date.")
        if errorflag == 0:
            inclusive = ' (excl. start and end dates)'
            if self.f.includeDays.isChecked() == 1 and self.f.checkBox.isChecked() != 1:
                inclusive = ' (incl. start date)'
            if self.f.includeDays.isChecked() != 1 and self.f.checkBox.isChecked() == 1:
                inclusive = ' (incl. end date)'
            if self.f.includeDays.isChecked() == 1 and self.f.checkBox.isChecked() == 1:
                inclusive = ' (incl. start and end dates)'
            self.f.questionLabel.setText("")
            self.f.answerLabel.setText("Calculating Answer ...")
            import get_config
            reload(get_config)
            getConfig = get_config.getConfig()
            from calculator import *
            working_matrix = ['',' working']
            month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
            answer = deltaDays(datetime(int(startdate.year()),int(startdate.month()),int(startdate.day())),datetime(int(enddate.year()),int(enddate.month()),int(enddate.day())),getConfig.fixed_raw,getConfig.variable_raw,getConfig.variable_ext_raw,getConfig.gf,getConfig.em,getConfig.grange_raw,self.f,int(self.f.workingDays.isChecked()),int(self.f.includeDays.isChecked()),int(self.f.checkBox.isChecked()))
            text = str(answer) + working_matrix[int(self.f.workingDays.isChecked())] + ' days between ' + str(startdate.day()) + ' ' + str(startdate.toString("MMMM")) + ' ' + str(startdate.year()) + ' and ' + str(enddate.day()) + ' ' + str(enddate.toString("MMMM")) + ' ' + str(enddate.year()) + inclusive
            self.f.answerLabel.setText(text)
                
    def startConfig(self):
        d = config()
        msg = d.exec_()
        if msg == 1:
            self.getTemplates()

class about(QtGui.QDialog):
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)
        self.f = Ui_About()
        self.f.setupUi(self)
        self.f.label_3.setText(str(currentVersion))



class config(QtGui.QDialog):
    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self, parent)
        self.f = Ui_config()
        self.f.setupUi(self)
        reload(get_config)
        config_data = get_config.getConfig()
        print config_data
        self.f.label_11.setText(config_data.tmplt)
        self.f.checkBox_2.setChecked(config_data.gf)
        self.f.checkBox_4.setChecked(config_data.es)
        self.f.checkBox_3.setChecked(config_data.em)
        month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
        rel_raw_matrix = ['First','Second','Third','Fourth','Last']
        wkday_raw_matrix = ['Monday','Tuesday','Wednesday','Thursday','Friday']
        fixed = config_data.fixed_dict
        variable = config_data.variable_dict
        variable_ext = config_data.variable_ext_dict
        print fixed
        print variable
        treelabels = ["Holiday","Date"]
        self.f.treeWidget.setHeaderLabels(treelabels)
        for i in fixed.keys():
            items = [str(i),str(fixed[i][0]) + ' ' + str(month_matrix[fixed[i][1]])]
            item = QtGui.QTreeWidgetItem(items)
            self.f.treeWidget.insertTopLevelItem(0,item)
        for i in variable.keys():
            items = [str(i),str(rel_raw_matrix[variable[i][0]]) + ' ' + str(wkday_raw_matrix[variable[i][1]]) + ' in ' + str(month_matrix[variable[i][2]])]
            item = QtGui.QTreeWidgetItem(items)
            self.f.treeWidget.insertTopLevelItem(0,item)
        for i in variable_ext.keys():
            print "i:"
            print i
            items = [str(i),'Closest ' + wkday_raw_matrix[variable_ext[i][0]] + ' to ' + str(variable_ext[i][3]) + ' ' + str(month_matrix[variable_ext[i][2]])]
            item = QtGui.QTreeWidgetItem(items)
            self.f.treeWidget.insertTopLevelItem(0,item)
        
        QtCore.QObject.connect(self.f.pushButton_2, QtCore.SIGNAL("clicked()"), self.setFixed)
        QtCore.QObject.connect(self.f.pushButton_4, QtCore.SIGNAL("clicked()"), self.setVariable)
        QtCore.QObject.connect(self.f.buttonBox, QtCore.SIGNAL("accepted()"), self.writeConfig)
        QtCore.QObject.connect(self.f.treeWidget, QtCore.SIGNAL("itemActivated(QTreeWidgetItem*, int)"), self.highLight)
        QtCore.QObject.connect(self.f.pushButton_5, QtCore.SIGNAL("clicked()"), self.removeCurrent)
        QtCore.QObject.connect(self.f.pushButton, QtCore.SIGNAL("clicked()"), self.changeDate)
        QtCore.QObject.connect(self.f.pushButton_3, QtCore.SIGNAL("clicked()"), self.changeDate)
        QtCore.QObject.connect(self.f.treeWidget, QtCore.SIGNAL("currentItemChanged(QTreeWidgetItem*, QTreeWidgetItem*)"), self.highLight)
        QtCore.QObject.connect(self.f.checkBox, QtCore.SIGNAL("stateChanged(int)"), self.rangeChange)
        QtCore.QObject.connect(self.f.pushButton_6, QtCore.SIGNAL("clicked()"), self.saveTemplt)

    def saveTemplt(self):
        tmpltname = QtGui.QInputDialog.getText(self.f.pushButton_6,"Template Name","Enter Template Name:")
        error = 0
        print tmpltname[0]
        if tmpltname[0].isEmpty() == True:
            QtGui.QMessageBox.critical(self.f.pushButton_6,"Name Missing","You must enter a template name.")
            error = 1
        if error == 0:
            print "into if"
            import os
            from ConfigParser import RawConfigParser
            from datetime import datetime
            from dateutil.rrule import *
            if os.name == 'nt':
                try:
                    os.mkdir(os.path.expandvars("%appdata%") + '\\date_calculator')
                except:
                    pass
                try:
                    os.mknod(os.path.expandvars("%appdata%") + '\\date_calculator\\' + tmpltname[0] + '.dctmplt')
                except:
                    pass
                confile = os.path.expandvars("%appdata%") + '\\date_calculator\\' + tmpltname[0] + '.dctmplt'
            else:
                home_directory = os.popen("echo $HOME").readline()[0:-1]
                try:
                    os.mkdir(home_directory + '/.date_config')
                except:
                    pass
                try:
                    os.mknod(home_directory + '/.date_config/' + tmpltname[0] + '.dctmplt')
                except:
                    pass
                confile = home_directory + '/.date_config/' + tmpltname[0] + '.dctmplt'
            config_file = open(confile, 'w')
            config_object = RawConfigParser()
            config_object.add_section('Holidays')
            month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
            rel_raw_matrix = ['First','Second','Third','Fourth','Last']
            wkday_raw_matrix = ['Monday','Tuesday','Wednesday','Thursday','Friday']
            variable = {}
            fixed = {}
            variable_ext = {}
            grange = {}
            for i in range(int(self.f.treeWidget.topLevelItemCount())):
                temp_var = []
                temp_fxd = []
                temp_var_ext = []
                temp_range = []
                if str(self.f.treeWidget.topLevelItem(i).text(1)).find('incl.') != -1:
                    text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                    print text_list
                    temp_range.append(int(text_list[0]))
                    temp_range.append(month_matrix.index(text_list[1]))
                    temp_range.append(int(text_list[3]))
                    temp_range.append(month_matrix.index(text_list[4]))
                    grange[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_range
                elif str(self.f.treeWidget.topLevelItem(i).text(1)).find('in') != -1:
                    text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                    temp_var.append(rel_raw_matrix.index(text_list[0]))
                    temp_var.append(wkday_raw_matrix.index(text_list[1]))
                    temp_var.append(month_matrix.index(text_list[3]))
                    variable[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_var
                elif str(self.f.treeWidget.topLevelItem(i).text(1)).find('Closest') != -1:
                    text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                    current_year = datetime.today().year
                    year_day = len(rrule(DAILY,byweekday=(0,1,2,3,4,5,6),dtstart=datetime(current_year,1,1)).between(datetime(current_year,1,1),datetime(current_year,month_matrix.index(text_list[4]) + 1,int(text_list[3])),True))
                    print year_day
                    day_list = []
                    for j in range((year_day-3),(year_day+4)):
                        day_list.append(j)
                    temp_var_ext.append(wkday_raw_matrix.index(text_list[1]))
                    temp_var_ext.append(day_list)
                    temp_var_ext.append(month_matrix.index(text_list[4]))
                    temp_var_ext.append(int(text_list[3]))
                    variable_ext[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_var_ext
                else:
                    text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                    temp_fxd.append(int(text_list[0]))
                    temp_fxd.append(month_matrix.index(text_list[1]))
                    fixed[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_fxd
            config_object.set('Holidays','template',str(tmpltname[0]))
            config_object.set('Holidays','fixed',str(fixed))
            config_object.set('Holidays','grange',str(grange))
            config_object.set('Holidays','variable',str(variable))
            config_object.set('Holidays','variable_ext',str(variable_ext))
            config_object.set('Holidays','gf',str(int(self.f.checkBox_2.isChecked())))
            config_object.set('Holidays','es',str(int(self.f.checkBox_4.isChecked())))
            config_object.set('Holidays','em',str(int(self.f.checkBox_3.isChecked())))
            config_object.write(config_file)
            config_file.close()

    def rangeChange(self,check):
        if check == 0:
            self.f.label_2.setEnabled(False)
            self.f.spinBox_2.setEnabled(False)
            self.f.comboBox_2.setEnabled(False)
        if check == 2:
            self.f.label_2.setEnabled(True)
            self.f.spinBox_2.setEnabled(True)
            self.f.comboBox_2.setEnabled(True)

    def setFixed(self):
        from datetime import datetime
        from dateutil.relativedelta import *
        flag = 0
        if len(str(self.f.lineEdit.displayText())) == 0:
            QtGui.QMessageBox.critical(self.f.lineEdit, "Label Missing", "You must enter a label.")
            flag = 1
        #for i in range(int(self.f.treeWidget.topLevelItemCount())):
            #if (str(self.f.treeWidget.topLevelItem(i).text(1))) == (str(self.f.spinBox.value()) + ' ' + str(self.f.comboBox.currentText())):
                #QtGui.QMessageBox.critical(self.f.treeWidget, "Double Entry", "You can't enter a date twice.")
                #flag = 1
                #break
        try:
            print datetime(2006,int(self.f.comboBox.currentIndex()) + 1,int(self.f.spinBox.value()))
        except ValueError:
            QtGui.QMessageBox.critical(self.f.spinBox, "Invalid Date", "The date entered is invalid.")
            flag = 1
        if self.f.checkBox.isChecked() == 1 and flag != 1:
            try:
                print datetime(2006,int(self.f.comboBox_2.currentIndex()) + 1,int(self.f.spinBox_2.value()))
            except ValueError:
                QtGui.QMessageBox.critical(self.f.spinBox, "Invalid Date", "The date entered is invalid.")
                flag = 1
        if self.f.checkBox.isChecked() == 1 and flag != 1:
            startdate = datetime(2006,int(self.f.comboBox.currentIndex()) + 1,int(self.f.spinBox.value()))
            enddate = datetime(2006,int(self.f.comboBox_2.currentIndex()) + 1,int(self.f.spinBox_2.value()))
            test = relativedelta(startdate,enddate)
            for i in (test.days, test.months, test.years):
                if i > 0:
                    flag = 1
                    QtGui.QMessageBox.critical(self.f.spinBox, "Invalid Range", "The start date must be earlier than the end date.")
        if self.f.checkBox.isChecked() == 1 and flag != 1:
            startdate = datetime(2006,int(self.f.comboBox.currentIndex()) + 1,int(self.f.spinBox.value()))
            enddate = datetime(2006,int(self.f.comboBox_2.currentIndex()) + 1,int(self.f.spinBox_2.value()))
            if startdate == enddate:
                flag = 1
                QtGui.QMessageBox.critical(self.f.spinBox, "Invalid Range", "The start and end dates may not be the same.")
                
        if flag != 1:
            if self.f.checkBox.isChecked() == 0:
                print str(self.f.comboBox.currentText())
                date_text = str(self.f.spinBox.value()) + ' ' + str(self.f.comboBox.currentText())
            else:
                print str(self.f.comboBox_2.currentText())
                date_text = str(self.f.spinBox.value()) + ' ' + str(self.f.comboBox.currentText()) + ' to ' + str(self.f.spinBox_2.value()) + ' ' + str(self.f.comboBox_2.currentText()) + ' (incl.)'
            label_text = self.f.lineEdit.displayText()
            items = [label_text,date_text]
            item = QtGui.QTreeWidgetItem(items)
            self.f.treeWidget.insertTopLevelItem(0,item)
            #self.f.fixed_set_3.setDisabled(True)
                
        

    def setVariable(self):
        from datetime import datetime
        flag = 0
        if len(str(self.f.lineEdit_2.displayText())) == 0:
            QMessageBox.critical(self.f.lineEdit_2, "Label Missing", "You must enter a label.")
            flag = 1
        if int(self.f.tabWidget_2.currentIndex()) == 0:
            for i in range(int(self.f.treeWidget.topLevelItemCount())):
                print self.f.treeWidget.topLevelItem(i).text(1)
                if (str(self.f.treeWidget.topLevelItem(i).text(1))) == (str(self.f.comboBox_3.currentText()) + ' ' + str(self.f.comboBox_4.currentText()) + ' in ' + str(self.f.comboBox_5.currentText())):
                    QtGui.QMessageBox.critical(self.f.treeWidget, "Double Entry", "You can't enter a date twice.")
                    flag = 1
                    break
        else:
            for i in range(int(self.f.treeWidget.topLevelItemCount())):
                if (str(self.f.treeWidget.topLevelItem(i).text(1))) == ('Closest ' + str(self.f.comboBox_6.currentText()) + ' to ' + str(self.f.spinBox_3.value()) + ' ' + str(self.f.comboBox_7.currentText())):
                    QtGui.QMessageBox.critical(self.f.treeWidget, "Double Entry", "You can't enter a date twice.")
                    flag = 1
                    break
        
        if flag != 1:
            if int(self.f.tabWidget_2.currentIndex()) == 0:
                date_text = str(self.f.comboBox_3.currentText()) + ' ' + str(self.f.comboBox_4.currentText()) + ' in ' + str(self.f.comboBox_5.currentText())
                label_text = str(self.f.lineEdit_2.displayText())
                items = [label_text,date_text]
                item = QtGui.QTreeWidgetItem(items)
                self.f.treeWidget.insertTopLevelItem(0,item)
            else:
                try:
                    print datetime(2006,int(self.f.comboBox_7.currentIndex()) + 1,int(self.f.spinBox_3.value()))
                except ValueError:
                    QMessageBox.critical(self.f.comboBox_7, "Invalid Date", "The date entered is invalid.")
                    flag = 1
                if flag != 1:
                    date_text = 'Closest ' + str(self.f.comboBox_6.currentText()) + ' to ' + str(self.f.spinBox_3.value()) + ' ' + str(self.f.comboBox_7.currentText())
                    label_text = str(self.f.lineEdit_2.displayText())
                    items = [label_text,date_text]
                    item = QtGui.QTreeWidgetItem(items)
                    self.f.treeWidget.insertTopLevelItem(0,item)
        

    def writeConfig(self):
        import os
        from ConfigParser import RawConfigParser
        from datetime import datetime
        from dateutil.rrule import *
        if self.f.label_11.text() == "Default":
            filename = 'date_config'
        else:
            filename = self.f.label_11.text() + '.dctmplt'
        if os.name == 'nt':
            try:
                os.mkdir(os.path.expandvars("%appdata%") + '\\date_calculator')
            except:
                pass
            try:
                os.mknod(os.path.expandvars("%appdata%") + '\\date_calculator\\' + filename)
            except:
                pass
            confile = os.path.expandvars("%appdata%") + '\\date_calculator\\' + filename
        else:
            home_directory = os.popen("echo $HOME").readline()[0:-1]
            try:
                os.mkdir(home_directory + '/.date_config')
            except:
                pass
            try:
                os.mknod(home_directory + '/.date_config/' + filename)
            except:
                pass
            confile = home_directory + '/.date_config/' + filename
        config_file = open(confile, 'w')
        config_object = RawConfigParser()
        if filename == 'date_config':
            config_object.add_section('Template')
            config_object.set('Template','current',self.f.label_11.text())
        try:
            config_object.add_section('Holidays')
        except:
            pass
        month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
        rel_raw_matrix = ['First','Second','Third','Fourth','Last']
        wkday_raw_matrix = ['Monday','Tuesday','Wednesday','Thursday','Friday']
        variable = {}
        fixed = {}
        variable_ext = {}
        grange = {}
        for i in range(int(self.f.treeWidget.topLevelItemCount())):
            temp_var = []
            temp_fxd = []
            temp_var_ext = []
            temp_range = []
            if str(self.f.treeWidget.topLevelItem(i).text(1)).find('incl.') != -1:
                text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                print text_list
                temp_range.append(int(text_list[0]))
                temp_range.append(month_matrix.index(text_list[1]))
                temp_range.append(int(text_list[3]))
                temp_range.append(month_matrix.index(text_list[4]))
                grange[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_range
            elif str(self.f.treeWidget.topLevelItem(i).text(1)).find('in') != -1:
                text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                temp_var.append(rel_raw_matrix.index(text_list[0]))
                temp_var.append(wkday_raw_matrix.index(text_list[1]))
                temp_var.append(month_matrix.index(text_list[3]))
                variable[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_var
            elif str(self.f.treeWidget.topLevelItem(i).text(1)).find('Closest') != -1:
                text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                current_year = datetime.today().year
                year_day = len(rrule(DAILY,byweekday=(0,1,2,3,4,5,6),dtstart=datetime(current_year,1,1)).between(datetime(current_year,1,1),datetime(current_year,month_matrix.index(text_list[4]) + 1,int(text_list[3])),True))
                print year_day
                day_list = []
                for j in range((year_day-3),(year_day+4)):
                    day_list.append(j)
                temp_var_ext.append(wkday_raw_matrix.index(text_list[1]))
                temp_var_ext.append(day_list)
                temp_var_ext.append(month_matrix.index(text_list[4]))
                temp_var_ext.append(int(text_list[3]))
                variable_ext[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_var_ext
            else:
                text_list = str(self.f.treeWidget.topLevelItem(i).text(1)).split()
                temp_fxd.append(int(text_list[0]))
                temp_fxd.append(month_matrix.index(text_list[1]))
                fixed[str(self.f.treeWidget.topLevelItem(i).text(0))] = temp_fxd
        config_object.set('Holidays','fixed',str(fixed))
        config_object.set('Holidays','grange',str(grange))
        config_object.set('Holidays','variable',str(variable))
        config_object.set('Holidays','variable_ext',str(variable_ext))
        config_object.set('Holidays','gf',str(int(self.f.checkBox_2.isChecked())))
        config_object.set('Holidays','es',str(int(self.f.checkBox_4.isChecked())))
        config_object.set('Holidays','em',str(int(self.f.checkBox_3.isChecked())))
        config_object.write(config_file)
        config_file.close()

    def highLight(self, item):
        print "into highLight"
        self.f.pushButton_5.setEnabled(True)
        if str(item.text(1)).find('incl.') != -1:
            self.f.tabWidget.setCurrentIndex(0)
            self.f.checkBox.setChecked(True)
            self.f.pushButton.setEnabled(True)
            date_text = str(item.text(1)).split()
            self.f.spinBox.setValue(int(date_text[0]))
            index = self.f.comboBox.findText(date_text[1])
            self.f.comboBox.setCurrentIndex(index)
            self.f.spinBox_2.setValue(int(date_text[3]))
            index = self.f.comboBox_2.findText(date_text[4])
            self.f.comboBox_2.setCurrentIndex(index)
            self.f.lineEdit.setText(str(item.text(0)))
        elif str(item.text(1)).find('in') != -1:
            self.f.tabWidget.setCurrentIndex(1)
            self.f.tabWidget_2.setCurrentIndex(0)
            self.f.pushButton_3.setEnabled(True)
            date_text = str(item.text(1)).split()
            index = self.f.comboBox_3.findText(date_text[0])
            self.f.comboBox_3.setCurrentIndex(index)
            index = self.f.comboBox_4.findText(date_text[1])
            self.f.comboBox_4.setCurrentIndex(index)
            index = self.f.comboBox_5.findText(date_text[3])
            self.f.comboBox_5.setCurrentIndex(index)
            self.f.lineEdit_2.setText(str(item.text(0)))
        elif str(item.text(1)).find('Closest') != -1:
            self.f.tabWidget.setCurrentIndex(1)
            self.f.tabWidget_2.setCurrentIndex(1)
            self.f.pushButton_3.setEnabled(True)
            date_text = str(item.text(1)).split()
            index = self.f.comboBox_6.findText(date_text[1])
            self.f.comboBox_6.setCurrentIndex(index)
            self.f.spinBox_3.setValue(int(date_text[3]))
            index = self.f.comboBox_7.findText(date_text[4])
            self.f.comboBox_7.setCurrentIndex(index)
            self.f.lineEdit_2.setText(str(item.text(0)))
        else:
            self.f.tabWidget.setCurrentIndex(0)
            self.f.checkBox.setChecked(False)
            self.f.pushButton.setEnabled(True)
            date_text = str(item.text(1)).split()
            self.f.spinBox.setValue(int(date_text[0]))
            index = self.f.comboBox.findText(date_text[1])
            self.f.comboBox.setCurrentIndex(index)
            self.f.lineEdit.setText(str(item.text(0)))
        

      

    def removeCurrent(self):
        self.f.treeWidget.takeTopLevelItem(int(self.f.treeWidget.indexOfTopLevelItem(self.f.treeWidget.currentItem())))

    def changeDate(self):
        if self.f.tabWidget.currentIndex() == 0:
            day_text = str(self.f.spinBox.value()) + ' ' + str(self.f.comboBox.currentText())
            newitems = [str(self.f.lineEdit.displayText()),day_text]
            newitem = QtGui.QTreeWidgetItem(newitems)
            index = int(self.f.treeWidget.indexOfTopLevelItem(self.f.treeWidget.currentItem()))
            self.f.treeWidget.takeTopLevelItem(index)
            self.f.treeWidget.insertTopLevelItem(index,newitem)
        else:
            if int(self.f.tabWidget_2.currentIndex()) == 0:
                day_text = str(self.f.comboBox_3.currentText()) + ' ' + str(self.f.comboBox_4.currentText()) + ' in ' + str(self.f.comboBox_5.currentText())
                newitems = [str(self.f.lineEdit_2.displayText()),day_text]
                newitem = QtGui.QTreeWidgetItem(newitems)
                index = int(self.f.treeWidget.indexOfTopLevelItem(self.f.treeWidget.currentItem()))
                self.f.treeWidget.takeTopLevelItem(index)
                self.f.treeWidget.insertTopLevelItem(index,newitem)
            else:
                day_text = 'Closest ' + str(self.f.comboBox_6.currentText()) + ' to ' + str(self.f.spinBox_3.value()) + ' ' + str(self.f.comboBox_7.currentText())
                newitems = [str(self.f.lineEdit_2.displayText()),day_text]
                newitem = QtGui.QTreeWidgetItem(newitems)
                index = int(self.f.treeWidget.indexOfTopLevelItem(self.f.treeWidget.currentItem()))
                self.f.treeWidget.takeTopLevelItem(index)
                self.f.treeWidget.insertTopLevelItem(index,newitem)

            


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    mw = mainwindow()
    mw.show()
    sys.exit(app.exec_())
