# -*- coding: utf-8 -*-
from ConfigParser import RawConfigParser
import os
from datetime import datetime, timedelta
from dateutil.rrule import *
from dateutil.parser import *
from dateutil.easter import *

wkday_matrix = [MO,TU,WE,TH,FR]
rel_matrix = [+1,+2,+3,+4,-1]

class getConfig:
    print "Getting Configuration ..."
    gf = 0
    es = 0
    em = 0
    fixed_raw = []
    variable_raw = []
    variable_ext_raw = []
    grange_raw = []
    fixed_dict = {}
    variable_dict = {}
    variable_ext_dict = {}
    grange_dict = {}
    tmplt = 'Default'
    if os.name == "nt":
        config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\date_config'
    else:
        home_directory = os.popen("echo $HOME").readline()[0:-1]
        config_file = home_directory + '/.date_config/date_config'
    config = RawConfigParser()
    try:
        config.read(config_file)
        tmplt = config.get('Template','current')
        if os.name == "nt":
            config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\' + tmplt + '.dctmplt'
        else:
            config_file = home_directory + '/.date_config/' + tmplt + '.dctmplt'
    except:
        pass
    try:
        config.read(config_file)
        fixed_dict = eval(config.get('Holidays','fixed'))
        variable_dict = eval(config.get('Holidays','variable'))
        variable_ext_dict = eval(config.get('Holidays','variable_ext'))
        grange_dict = eval(config.get('Holidays','grange'))
        gf = config.getint('Holidays','gf')
        es = config.getint('Holidays','es')
        em = config.getint('Holidays','em')
        fixed_raw = []
        for i in fixed_dict.keys():
            fixed_raw.append([fixed_dict[i][0],fixed_dict[i][1] + 1])
        print "fixed_raw:"
        print fixed_raw
        variable_raw = []
        for i in variable_dict.keys():
            variable_raw.append([rel_matrix[variable_dict[i][0]],wkday_matrix[variable_dict[i][1]],variable_dict[i][2] + 1])
        print "variable_raw:"
        print variable_raw
        variable_ext_raw = []
        for i in variable_ext_dict.keys():
            variable_ext_raw.append([wkday_matrix[variable_ext_dict[i][0]],variable_ext_dict[i][1],variable_ext_dict[i][2] + 1])
        print "variable_ext_raw:"
        print variable_ext_raw
        grange_raw = []
        for i in grange_dict.keys():
            start = datetime(2006,grange_dict[i][1] + 1,grange_dict[i][0])
            end = datetime(2006,grange_dict[i][3] + 1,grange_dict[i][2])
            r = (end+timedelta(days=1)-start).days
            dateList = [start+timedelta(days=j) for j in range(r)]
            print start
            print end
            print dateList
            for p in dateList:
                raw = str(p)
                thisdate = raw.split()[0].split('-')
                thismonth = int(thisdate[1])
                thisday = int(thisdate[2])
                grange_raw.append([thisday,thismonth])
        print "grange_raw:"
        print grange_raw
        
    except:
        print "Couldn't get data from file.  Using defaults ..."
    #return (gf,es,em,fixed_raw,variable_raw,variable_ext_raw,grange_raw)
