# -*- coding: utf-8 -*-

from reportlab.pdfgen import canvas
from reportlab.lib.pagesizes import letter, A4
from reportlab.lib.styles import getSampleStyleSheet, ParagraphStyle
from reportlab.platypus import SimpleDocTemplate, Spacer, Paragraph, Frame, Table, TableStyle, XPreformatted, Image, Flowable, KeepTogether, PageBreak, CondPageBreak
from reportlab.lib import colors
from reportlab.lib.utils import ImageReader
from reportlab.rl_config import defaultPageSize
from reportlab.lib.units import cm
import datetime
import os
from ConfigParser import RawConfigParser
day_matrix = ['Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday']
month_matrix = ['January','February','March','April','May','June','July','August','September','October','November','December']
week_matrix = ['First','Second','Third','Fourth','Fifth']
PAGE_HEIGHT=defaultPageSize[1]
PAGE_WIDTH=defaultPageSize[0]
styles = getSampleStyleSheet()

def myFirstPage(canvas, doc):
    global dialog,Story
    canvas.saveState()

    canvas.setFont('Helvetica-Bold', 20)
    canvas.drawString(1.4 * cm, PAGE_HEIGHT - 1.7 * cm, "Date Calculator::Date Calculation Report")

    canvas.setLineWidth(0.02*cm)
    canvas.setFont('Helvetica-Bold', 14)
    canvas.line(1.2*cm, PAGE_HEIGHT - 1.8*cm, PAGE_WIDTH - 1.2*cm, PAGE_HEIGHT - 1.8*cm)
    canvas.drawString(1.4 * cm, PAGE_HEIGHT - 3 * cm, "Calculation")
    canvas.line(1.2*cm, PAGE_HEIGHT - 3.1*cm, PAGE_WIDTH - 1.2*cm, PAGE_HEIGHT - 3.1*cm)
    canvas.setFont('Helvetica-Bold', 10)
    if len(dialog.questionLabel.text()) != 0:
        canvas.drawString(1.4 * cm, PAGE_HEIGHT - 4 * cm, "Query:")
        canvas.setFont('Helvetica', 10)
        canvas.drawString(4 * cm, PAGE_HEIGHT - 4 * cm, str(dialog.questionLabel.text()))
    canvas.setFont('Helvetica-Bold', 10)
    canvas.drawString(1.4 * cm, PAGE_HEIGHT - 5 * cm, "Answer:")
    canvas.setFont('Helvetica', 10)
    canvas.drawString(4 * cm, PAGE_HEIGHT - 5 * cm, str(dialog.answerLabel.text()))
    if dialog.workingDays.isChecked() == 1:
        canvas.setFont('Helvetica-Bold', 14)
        canvas.drawString(1.4 * cm, PAGE_HEIGHT - 6 * cm, "Holidays Used In Calculation")
        canvas.line(1.2*cm, PAGE_HEIGHT - 6.1*cm, PAGE_WIDTH - 1.2*cm, PAGE_HEIGHT - 6.1*cm)
        canvas.setFont('Helvetica-Bold', 10)
        canvas.drawString(1.4 * cm, PAGE_HEIGHT - 6.5 * cm, "Template:")
        canvas.setFont('Helvetica', 10)
        canvas.drawString(4 * cm, PAGE_HEIGHT - 6.5 * cm, str(dialog.comboBox.currentText()))
        data = getHolidays(dialog)
        canvas.setFont('Helvetica-Bold', 10)
        canvas.drawString(1.4 * cm, PAGE_HEIGHT - 7.5 * cm, "Holiday")
        canvas.drawString(6 * cm, PAGE_HEIGHT - 7.5 * cm, "Date")
        canvas.setFont('Helvetica', 10)
        vpos = 8
        for i in data:
            canvas.drawString(1.4 * cm, PAGE_HEIGHT - vpos * cm, i[0])
            canvas.drawString(7 * cm, PAGE_HEIGHT - vpos * cm, i[1])
            vpos += 0.5
            if vpos > 26.7:
                #footer
                today = datetime.date.today()
                day = today.strftime("%d")
                month = today.strftime("%B")
                year = today.strftime("%Y")
                def ordinalth(n):
                    t = 'th st nd rd th th th th th th'.split()
                    if n % 100 in (11, 12, 13): #special case
                        return '%dth' % n
                    return str(n) + t[n % 10]
                day = ordinalth(int(day))
                curdate = "%s %s, %s" % (month, day, year)
                canvas.setLineWidth(0.02*cm)
                canvas.line(1.4*cm, 2*cm, PAGE_WIDTH - 1.4*cm, 2*cm)
                canvas.setFont('Helvetica',9)
                canvas.drawString(1.5*cm, 1.5 * cm, "Date Calulator :: http://legaldatecalculator.com :: Report Generated " + curdate)
                canvas.showPage()
                canvas.setFont('Helvetica', 10)
                vpos = 3
        vpos += 2
        canvas.setFont('Helvetica-Bold', 14)
        canvas.drawString(1.4 * cm, PAGE_HEIGHT - vpos * cm, "Log Of Working Day Analysis")
        vpos += 0.1
        canvas.line(1.2*cm, PAGE_HEIGHT - vpos*cm, PAGE_WIDTH - 1.2*cm, PAGE_HEIGHT - vpos*cm)
        wkgtext = dialog.textEdit.toPlainText()
        wkgtext = str(wkgtext).split('\n')
        canvas.setFont('Helvetica', 10)
        vpos += 1
        for i in wkgtext:
            canvas.drawString(1.4 * cm, PAGE_HEIGHT - vpos * cm, i)
            Story.append(CondPageBreak(3*cm))
            vpos += 0.5
            if vpos > 26.7:
                #footer
                today = datetime.date.today()
                day = today.strftime("%d")
                month = today.strftime("%B")
                year = today.strftime("%Y")
                def ordinalth(n):
                    t = 'th st nd rd th th th th th th'.split()
                    if n % 100 in (11, 12, 13): #special case
                        return '%dth' % n
                    return str(n) + t[n % 10]
                day = ordinalth(int(day))
                curdate = "%s %s, %s" % (month, day, year)
                canvas.setLineWidth(0.02*cm)
                canvas.line(1.4*cm, 2*cm, PAGE_WIDTH - 1.4*cm, 2*cm)
                canvas.setFont('Helvetica',9)
                canvas.drawString(1.5*cm, 1.5 * cm, "Date Calulator :: http://legaldatecalculator.com :: Report Generated " + curdate)
                canvas.showPage()
                canvas.setFont('Helvetica', 10)
                vpos = 3
        
    #canvas.drawRightString(PAGE_WIDTH - 1.4*cm, PAGE_HEIGHT - 1.5*cm, "%s, %s, %s %s" % (taaddress, tacity, taprovince, tapostalcode))
    #canvas.drawRightString(PAGE_WIDTH - 1.4*cm, PAGE_HEIGHT - 1.9*cm, "%s  Fax: %s" % (self.format_phonenumber(taphone), self.format_phonenumber(tafax)))

    #canvas.setLineWidth(0.02*cm)
    #canvas.line(1.4*cm, PAGE_HEIGHT - 2.1*cm, PAGE_WIDTH - 1.4*cm, PAGE_HEIGHT - 2.1*cm)

    #canvas.setFont('Helvetica-Bold', 12)
    #today = datetime.date.today()
    #day = today.strftime("%d")
    #month = today.strftime("%B")
    #year = today.strftime("%Y")
    #def ordinalth(n):
        #t = 'th st nd rd th th th th th th'.split()
        #if n % 100 in (11, 12, 13): #special case
            #return '%dth' % n
        #return str(n) + t[n % 10]
    #day = ordinalth(int(day))
    #curdate = "%s %s, %s" % (month, day, year)
    #canvas.drawRightString(PAGE_WIDTH - 1.4 *cm, PAGE_HEIGHT - 2.6 * cm, curdate)

    #canvas.setStrokeColorRGB(0.5,0.5,0.5)
    #canvas.setFillColorRGB(0.5,0.5,0.5)

    #canvas.setFont('Helvetica-Bold', 26)    
    #canvas.drawString(1.4*cm, PAGE_HEIGHT - 3.2 * cm, "Accounts Receivable")

    #canvas.setStrokeColorRGB(0,0,0)
    #canvas.setFillColorRGB(0,0,0)


    #footer
    today = datetime.date.today()
    day = today.strftime("%d")
    month = today.strftime("%B")
    year = today.strftime("%Y")
    def ordinalth(n):
        t = 'th st nd rd th th th th th th'.split()
        if n % 100 in (11, 12, 13): #special case
            return '%dth' % n
        return str(n) + t[n % 10]
    day = ordinalth(int(day))
    curdate = "%s %s, %s" % (month, day, year)
    canvas.setLineWidth(0.02*cm)
    canvas.line(1.4*cm, 2*cm, PAGE_WIDTH - 1.4*cm, 2*cm)
    canvas.setFont('Helvetica',9)
    canvas.drawString(1.5*cm, 1.5 * cm, "Date Calulator :: http://legaldatecalculator.com :: Report Generated " + curdate)

    #canvas.restoreState()


def myLaterPages(canvas, doc):

    canvas.saveState()

    #footer
    canvas.setLineWidth(0.02*cm)
    canvas.line(1.2*cm, 2*cm, PAGE_WIDTH - 1.2*cm, 2*cm)

    canvas.setFont('Helvetica',9)
    canvas.drawString(1.3*cm, 1.5 * cm, "Date Calulator :: http://legaldatecalculator.com")

    canvas.doForm('lastPageNumber')
    canvas.setFont('Helvetica',9)
    canvas.drawRightString(PAGE_WIDTH - 2 * cm, 1.5 * cm, "Page %d of" % (doc.page, ))
    canvas.restoreState()

def go(filename,passdialog):
    global dialog,Story
    dialog = passdialog
    doc = SimpleDocTemplate(filename, allowSplitting=1, pagesize=A4)
            # optional SimpleDocTemplate vars leftMargin=1.5*cm, rightMargin=1.5*cm
    Story = [Spacer(1,1.6*cm)]
    style = styles["Normal"]


    class lastPageNumberFlowable(Flowable):

        def __init__(self, xoffset = 0, yoffset = 0):
            Flowable.__init__(self)
            self._xoffset = xoffset
            self._yoffset = yoffset

        def draw(self):
            canvas = self.canv

            if not canvas.hasForm("lastPageNumber"):
                canvas.beginForm('lastPageNumber')
                #canvas.translate(0,1 * cm) #Make origin to left corner of letter portrait page
                canvas.setFont('Times-Roman',9)
                canvas.drawString(PAGE_WIDTH - 1.9 * cm, 1.5 * cm, "%d" % (doc.page, ))
                #drawBox(canvas)
                canvas.endForm()

    x = lastPageNumberFlowable()
    Story.append(x)

    doc.build(Story, onFirstPage=myFirstPage, onLaterPages=myLaterPages)


#Elements.append(Paragraph("Date Calculator::Date Calculation Report", styles["Heading1"]))
#if len(dialog.questionLabel.text()) != 0:
    #Elements.append(Paragraph(str("Query:  " + dialog.questionLabel.text()), styles["Normal"]))
#Elements.append(Paragraph(str("Answer:  " + dialog.answerLabel.text()), styles["Normal"]))
#Elements.append(Paragraph("Template Information", styles["Heading2"]))
#Elements.append(Paragraph(str("Holiday Template Used:  " + dialog.comboBox.currentText()), styles["Normal"]))
#data = getHolidays(dialog)
#if len(data) > 1:
    #ts = [('ALIGN', (1,1), (-1,-1), 'LEFT'),
    #('LINEABOVE', (0,0), (-1,0), 1, colors.black),
    #('LINEBELOW', (0,0), (-1,0), 1, colors.black),
    #('FONT', (0,0), (-1,0), 'Times-Bold')]
    #table = Table(data, style=ts)
    #Elements.append(table)
#if dialog.workingDays.isChecked() == True:
    #Elements.append(Paragraph("Log of Working Day analysis:", styles["Heading2"]))

#doc.build(Elements)

def getHolidays(dialog):
    if dialog.comboBox.currentText() == 'None':
        filename = 'date_config'
    else:
        filename = str(dialog.comboBox.currentText()) + '.dctmplt'
    if os.name == "nt":
        config_file = os.path.expandvars("%appdata%") + '\\date_calculator\\' + filename
    else:
        home_directory = os.popen("echo $HOME").readline()[0:-1]
        config_file = home_directory + '/.date_config/' + filename
    config = RawConfigParser()
    print config_file
    #try:
    config.read(config_file)
    fixed_dict = eval(config.get('Holidays','fixed'))
    variable_dict = eval(config.get('Holidays','variable'))
    variable_ext_dict = eval(config.get('Holidays','variable_ext'))
    grange_dict = eval(config.get('Holidays','grange'))
    gf = config.getint('Holidays','gf')
    es = config.getint('Holidays','es')
    em = config.getint('Holidays','em')
    hollist = []
    for key in fixed_dict:
        temp = []
        temp.append(key)
        temp.append(str(fixed_dict[key][0]) + ' ' + month_matrix[fixed_dict[key][1]])
        hollist.append(temp)
    for key in grange_dict:
        temp = []
        temp.append(key)
        temp.append('From ' + str(grange_dict[key][0]) + ' ' + month_matrix[grange_dict[key][1]] + ' to ' + str(grange_dict[key][2]) + ' ' + month_matrix[grange_dict[key][3]])
        hollist.append(temp)
    for key in variable_dict:
        temp = []
        temp.append(key)
        temp.append('The ' + week_matrix[variable_dict[key][0]] + ' ' + day_matrix[variable_dict[key][1]] + ' in ' + month_matrix[variable_dict[key][2]])
        hollist.append(temp)
    for key in variable_ext_dict:
        temp = []
        temp.append(key)
        temp.append('The Closest ' + day_matrix[variable_ext_dict[key][0]] + ' to ' + str(variable_ext_dict[key][3]) + ' ' + month_matrix[variable_ext_dict[key][2]])
        hollist.append(temp)
    if gf == 1:
        hollist.append(['Good Friday',''])
    if es == 1:
        hollist.append(['Easter Sunday',''])
    if em == 1:
        hollist.append(['Easter Monday',''])
    return hollist

